import { j as t } from "../../../node_modules/react/jsx-runtime.mjs";
import { useContext as Ne, useState as X, useMemo as w, useRef as P, useEffect as ve, useCallback as Te } from "react";
import { isMobile as T } from "../../../node_modules/react-device-detect/dist/lib.mjs";
import { theme as Me, Table as A, Skeleton as ze } from "antd";
import ke from "../../../node_modules/classnames/index.mjs";
import We from "../../BitzDrawer/index.mjs";
import Le from "../../BitzPagination/index.mjs";
import Pe from "../../BitzNoData/index.mjs";
import "../../BitzList/index.less.mjs";
import Ae from "../../BitzList/List.mjs";
import "../../BitzPullRefresh/style/index.less.mjs";
import He from "../../BitzPullRefresh/PullRefresh.mjs";
import Se, { TableContext as Ee } from "../Store/index.mjs";
import Oe from "../TableSkeleton/index.mjs";
import { columnSort as F, genColumnKey as J } from "../Store/utils/index.mjs";
import H from "../../../node_modules/ahooks/es/useSize/index.mjs";
import Ve from "../ActionCol/style.mjs";
import "./index.less.mjs";
import _e from "../../../node_modules/lodash-es/at.mjs";
function $e({
  showPagination: j = !0,
  fillEvenRow: S = !0,
  evenRowBgColor: De = "#f9f9f9",
  height: m,
  dataSource: l = [],
  total: M = 0,
  columns: u,
  loading: B = !1,
  skeletonNum: Q = 2,
  skeletonRender: E,
  skeletonRowNum: Y = 4,
  skeletonRowsWidth: Z = ["35%", "100%", "100%", "60%"],
  mobileLoadEmit: I,
  mobileRefreshEmit: O,
  operationFilter: z,
  enableControlPage: ee,
  pagination: ne,
  paginationEmit: te = () => {
  },
  mobilePageHeight: Ke = 500,
  mobileCancelText: se = "取消",
  noDataTitle: le,
  noDataImg: oe,
  color: Re,
  size: V,
  showTableTool: re = !0,
  tableAction: ie,
  tableToolbar: ae,
  selectionBar: he,
  scroll: h,
  resetPage: ce,
  ...c
}) {
  const { token: de } = Me.useToken(), { gap: fe } = Ve(), d = Ne(Ee), [xe, k] = X(!1), ue = w(() => !!(l != null && l.length) && (l == null ? void 0 : l.length) >= M, [l, M]), [be, ge] = X([]), pe = (e, n) => {
    var i;
    const s = (i = z == null ? void 0 : z(e, n)) == null ? void 0 : i.filter(
      (o) => o.type !== "divider"
    );
    s != null && s.length && (ge(s), k(!0));
  }, _ = () => {
    k(!1);
  }, we = (e) => {
    var n;
    k(!1), (n = e.onClick) == null || n.call(e);
  }, b = P(null), g = H(b), C = P(null), W = H(C), $ = P(null), p = H($), ye = () => {
    var s;
    const e = (s = C.current) == null ? void 0 : s.querySelectorAll(
      ".ant-table-body tr:not(.ant-table-measure-row)"
    ), n = [];
    if (e == null || e.forEach((i) => {
      var o;
      n.push(
        ((o = i.querySelector(".operationCol .actionGroup")) == null ? void 0 : o.clientWidth) || 0
      );
    }), n.length)
      return Math.ceil(Math.max(...n)) + fe * 2;
  }, D = () => {
    var o;
    const e = (o = C.current) == null ? void 0 : o.querySelector(
      ".ant-table-body"
    ), n = e == null ? void 0 : e.clientWidth, s = ((e == null ? void 0 : e.offsetWidth) || 0) - n, i = s > 0;
    return { tbodyWidth: n, scrollBarWidth: s, hasScrollBar: i };
  }, je = (e) => {
    const n = e.length, s = e.filter((x) => x.width), o = s.map((x) => x.width).reduce((x, Ce) => x + Ce, 0);
    let a = 0;
    if (b.current) {
      const x = window.getComputedStyle(b.current);
      a = parseInt(x.getPropertyValue("--toolCell-width"));
    }
    let r = 0;
    c.rowSelection && (r += a), c.expandable && (r += a);
    const { tbodyWidth: v } = D(), f = parseInt(`${N.x}`) || 0, Be = Math.max(f, v), U = (parseInt(`${Be}`) || 0) - o - r;
    return U >= 0 ? U / (n - s.length) : void 0;
  }, { y: L, hasScrollBar: K } = w(() => {
    if (typeof m > "u")
      return {};
    const { hasScrollBar: e } = D();
    let n = 40, s = 40, i = 10;
    if (b.current) {
      const f = window.getComputedStyle(b.current);
      n = parseInt(f.getPropertyValue("--cell-block")), s = parseInt(f.getPropertyValue("--toolbar-height")), i = parseInt(f.getPropertyValue("--container-gap")) || 0;
    }
    const o = (p == null ? void 0 : p.height) || 0, a = o ? i : 0;
    return { y: m - o - a - s - n, hasScrollBar: e };
  }, [
    m,
    p == null ? void 0 : p.height,
    g == null ? void 0 : g.height,
    W == null ? void 0 : W.height
  ]), N = w(() => h != null && h.x ? { x: h.x, y: h.y || L } : h != null && h.y ? { x: 1e3, y: h.y } : { x: 1e3, y: L }, [h, L]), y = w(() => {
    const e = (a) => a.map((r) => {
      const v = J(
        (r == null ? void 0 : r.key) || (r == null ? void 0 : r.dataIndex),
        r.index
      ), f = d.columnsMap[v];
      return f && f.show === !1 ? !1 : r.children ? {
        ...r,
        children: e(r.children)
      } : r;
    }).filter(Boolean), n = e(u);
    if (T)
      return n.sort(F(d.columnsMap));
    const s = n.sort(F(d.columnsMap)), i = je(s), o = s.map((a) => ({
      ...a,
      ...a.width ? {
        width: a.useMaxWidth ? ye() ?? a.width : a.width
      } : {
        // 给未设置width的列设置平均数
        width: i
      }
    }));
    return [A.SELECTION_COLUMN, A.EXPAND_COLUMN, ...o];
  }, [
    d.columnsMap,
    u,
    T,
    N.x,
    c.rowSelection,
    c.expandable,
    g == null ? void 0 : g.height
  ]);
  ve(() => {
    if (u && u.length > 0) {
      const e = u.map(
        (n) => (
          // @ts-ignore
          J((n == null ? void 0 : n.key) ?? (n == null ? void 0 : n.dataIndex), n == null ? void 0 : n.dataIndex)
        )
      );
      d.setSortKeyColumns(e);
    }
  }, [u]);
  const R = w(() => `${V ?? (d == null ? void 0 : d.tableSize) ?? "lg"}BitzTable`, [V, d.tableSize]), me = w(() => ke(
    "bitzTableContainer",
    /* "hideBorder", */
    { hasScrollBar: K },
    R
  ), [R, K]), q = Te(
    (e, n) => S ? n % 2 === 0 ? "oddRow" : "evenRow" : "",
    [S]
  ), G = /* @__PURE__ */ t.jsx(
    Ae,
    {
      finished: ue,
      onLoad: I,
      loadingText: "加载中...",
      finishedText: "没有更多了",
      errorText: "加载失败",
      children: /* @__PURE__ */ t.jsxs("div", { className: "mobileTable", children: [
        l == null ? void 0 : l.map((e, n) => /* @__PURE__ */ t.jsx(
          "div",
          {
            className: "mobileTableRow",
            onClick: () => pe(e, n),
            children: /* @__PURE__ */ t.jsx("div", { className: "rowBox", children: y == null ? void 0 : y.map((s, i) => {
              var o;
              return /* @__PURE__ */ t.jsx("div", { children: !(s != null && s.mobileHide) && /* @__PURE__ */ t.jsxs("div", { className: "row", children: [
                !s.mobileHideLabel && /* @__PURE__ */ t.jsxs("div", { className: "label", children: [
                  `${s.title}`,
                  "："
                ] }),
                /* @__PURE__ */ t.jsx("div", { className: "value", children: ((o = s == null ? void 0 : s.render) == null ? void 0 : o.call(
                  s,
                  _e(e, (s == null ? void 0 : s.dataIndex) || ""),
                  e,
                  n
                )) || (e == null ? void 0 : e[s.dataIndex]) })
              ] }) }, i);
            }) })
          },
          n
        )),
        B && Array.from({ length: Q }).map((e, n) => /* @__PURE__ */ t.jsx("div", { className: "mobileTableRow", children: /* @__PURE__ */ t.jsx("div", { className: "rowBox", children: E ? E() : /* @__PURE__ */ t.jsx(
          ze,
          {
            title: !1,
            paragraph: {
              rows: Y,
              width: Z
            },
            active: !0
          }
        ) }) }, n))
      ] })
    }
  );
  return /* @__PURE__ */ t.jsxs("div", { className: "bitzTableBlock", children: [
    !T && /* @__PURE__ */ t.jsxs("div", { ref: b, className: me, style: { height: m }, children: [
      /* @__PURE__ */ t.jsxs("div", { className: "bitzTableContainerBody", ref: C, children: [
        re && /* @__PURE__ */ t.jsxs("div", { className: "bitzTableToolbarBlock", children: [
          ie || /* @__PURE__ */ t.jsx("div", {}),
          ae,
          (c == null ? void 0 : c.rowSelection) && /* @__PURE__ */ t.jsx(t.Fragment, { children: he })
        ] }),
        /* @__PURE__ */ t.jsx(
          A,
          {
            columns: y,
            dataSource: l,
            loading: !1,
            pagination: !1,
            scroll: N,
            ...c,
            rowClassName: q
          }
        ),
        /* @__PURE__ */ t.jsx(
          Oe,
          {
            columns: y,
            dataLength: l.length,
            scroll: N,
            rowSelection: c.rowSelection,
            expandable: c.expandable,
            rowClassName: q,
            loading: B
          }
        )
      ] }),
      j && /* @__PURE__ */ t.jsx(
        Le,
        {
          elRefInstance: $,
          enableControl: ee,
          pagination: ne,
          total: M,
          dataSource: l,
          resetPage: ce,
          paginationEmit: te
        }
      )
    ] }),
    T && /* @__PURE__ */ t.jsxs(t.Fragment, { children: [
      (B || (l == null ? void 0 : l.length) > 0) && /* @__PURE__ */ t.jsx(t.Fragment, { children: O ? /* @__PURE__ */ t.jsx(He, { onRefresh: O, children: G }) : G }),
      !B && /* @__PURE__ */ t.jsx(Pe, { data: l, title: le, img: oe }),
      /* @__PURE__ */ t.jsx(
        We,
        {
          className: "tableMobileDrawer",
          open: xe,
          placement: "bottom",
          height: "auto",
          closable: !1,
          onClose: _,
          children: /* @__PURE__ */ t.jsxs("div", { className: "drawerBox", children: [
            /* @__PURE__ */ t.jsx("div", { className: "boxBody", children: be.map((e, n) => /* @__PURE__ */ t.jsx(
              "div",
              {
                className: "operaList",
                onClick: () => we(e),
                ...e.danger && {
                  style: { color: de.colorError }
                },
                children: e.label
              },
              n
            )) }),
            /* @__PURE__ */ t.jsx("div", { className: "boxLine" }),
            /* @__PURE__ */ t.jsx("div", { className: "boxFooter", onClick: _, children: se })
          ] })
        }
      )
    ] })
  ] });
}
const cn = (j) => (
  // @ts-ignore
  /* @__PURE__ */ t.jsx(Se, { initValue: j, children: /* @__PURE__ */ t.jsx($e, { ...j }) })
);
export {
  cn as default
};
